#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=DEB_AvAntiAd.ico
#AutoIt3Wrapper_Outfile=DEB_AvAntiAd.exe
#AutoIt3Wrapper_Outfile_x64=DEB_AvAntiAd_x64.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=Blockiert die Werbeprozesse von Avira
#AutoIt3Wrapper_Res_Fileversion=1.1.0.0
#AutoIt3Wrapper_Res_LegalCopyright=2013 by MJ & Lunke
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_Res_requestedExecutionLevel=requireAdministrator
#AutoIt3Wrapper_Res_Field=ProductName|DEB_AvAntiAd
#AutoIt3Wrapper_Res_Field=ProductVersion|1.1.0
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <GUIConstants.au3>
#include 'Permissions.au3'

; Declarations

Opt('MustDeclareVars', 1)
Opt('TrayIconHide', 1)

Const $FILE_COUNT = 3			; The number files to dispatch

Const $FILE_NAME[$FILE_COUNT]	= 	['avnotify.exe', _
									'ipmgui.exe', _
									'apnstub.exe']		; Name of executables to dispatch

Const $HKLM_DEB = 'HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Image File Execution Options\'
Const $HKLM64_DEB = 'HKLM64\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Image File Execution Options\'
Const $DUMMY_FILE = 'dummy.exe'
Const $REG_SZ = 'REG_SZ'
Const $REG_VAL_DEBUGGER = 'Debugger'

Const $AppTitle = 'Avira Werbeblocker'
Const $AppVersion = '1.1.0'

Global $DummyPath = @WindowsDir & '\' & $DUMMY_FILE;

Global $isX64OS = (StringInStr(@OSArch, '64') > 0);

Main()

Func Main()

	_InitiatePermissionResources()

	GUICreate ($AppTitle, 340, 50)

	Opt('GUICoordMode', 3)

	Local $cmdInstall = GUICtrlCreateButton('Installieren', 10, 10, 100)
	Local $cmdRemove = GUICtrlCreateButton('Entfernen', 120, 10, 100)
	Local $cmdStatus = GUICtrlCreateButton('Status', 230, 10, 100)

	GUISetState(@SW_SHOW)

	While (true)

		Local $msg = GUIGetMsg()

		Select
			Case $msg = $GUI_EVENT_CLOSE
				ExitLoop
			Case $msg = $cmdInstall
				Install()
			Case $msg = $cmdRemove
				Remove()
			Case $msg = $cmdStatus
				ShowState()
		EndSelect
	WEnd

	_ClosePermissionResources()

EndFunc

Func Install()

	FileInstall('C:\Tools\AvAntiAd\source\dummy\dummy.exe', $DummyPath, 1)

	; Deny all system access - everybody else: read only
	Local $regPerm[4][3] = [['Administrators', 1, $REG_GENERIC_READ], _
							['System', 0, $GENERIC_ALL], _
							['Users', 1, $REG_GENERIC_READ], _
							['Authenticated Users', 1, $REG_GENERIC_READ]];

	; Try to fool avira by creating the keys several times in a row (worked for me even when avira product protection was enabled)
	For $j = 1 to 10

		For $i = 0 To $FILE_COUNT - 1
			RegWrite($HKLM_DEB & $FILE_NAME[$i], $REG_VAL_DEBUGGER, $REG_SZ, $DUMMY_FILE)

			_SetObjectPermissions($HKLM_DEB & $FILE_NAME[$i], $regPerm, $SE_REGISTRY_KEY, '', 1)

			If $isX64OS Then
				RegWrite($HKLM64_DEB & $FILE_NAME[$i], $REG_VAL_DEBUGGER, $REG_SZ, $DUMMY_FILE)

				_SetObjectPermissions($HKLM64_DEB & $FILE_NAME[$i], $regPerm, $SE_REGISTRY_KEY, '', 1)

			EndIf
		Next

		Sleep(25)
	Next

	MsgBox(64, $AppTitle, 'Der Avira Werbeschutz wurde installiert.')

EndFunc

Func Remove()

	FileDelete($DummyPath)

	For $i = 0 To $FILE_COUNT - 1

		; Restore full access to make the key removable
		_GrantAllAccess($HKLM_DEB & $FILE_NAME[$i], $SE_REGISTRY_KEY)

		RegDelete($HKLM_DEB & $FILE_NAME[$i])
		If $isX64OS Then

			; Restore full access to make the key removable
			_GrantAllAccess($HKLM64_DEB & $FILE_NAME[$i], $SE_REGISTRY_KEY)

			RegDelete($HKLM64_DEB & $FILE_NAME[$i])
		EndIf
	Next

	MsgBox(64, $AppTitle, 'Der Avira Werbeschutz wurde entfernt.')

EndFunc

Func ShowState()

	Local $expectedResult = 1 + ( $FILE_COUNT * ( 1 + Int($isX64OS) ) )

	Local $modCount = Int( FileExists($DummyPath) )

	For $i = 0 To $FILE_COUNT - 1
		$modCount += Int( StringCompare( RegRead($HKLM_DEB & $FILE_NAME[$i], $REG_VAL_DEBUGGER), $DUMMY_FILE) = 0)
		If $isX64OS Then
			$modCount += Int( StringCompare( RegRead($HKLM64_DEB & $FILE_NAME[$i], $REG_VAL_DEBUGGER), $DUMMY_FILE) = 0)
		EndIf
	Next

	Local $status = 'Der Avira Werbeschutz '
	Local $flag = 64;

	If $modCount = 0 Then
		$status &= 'ist nicht aktiv.'
	ElseIf $modCount >= $expectedResult Then
		$status &= 'ist aktiv.'
	Else
		$status &= ' ist nur unvollstndig aktiv, bitte erneut installieren.'
		Local $flag = 48;
	EndIf

	MsgBox($flag, 'ber ' & $AppTitle, $AppTitle & ' - ' & $AppVersion & @CRLF & _
				'(c) 2013 by MJ & Lunke' & @CRLF & _
				'Blockiert die Werbeprozesse von Avira.' & @CRLF & @CRLF & _
				'Status: ' & $status)

EndFunc
